/**
*
* COPYRIGHT:
*
*   Unless otherwise noted, all files are Copyright (c) 1999 Amiga, Inc.
*   All rights reserved.
*
* DISCLAIMER:
*
*   This software is provided "as is". No representations or warranties
*   are made with respect to the accuracy, reliability, performance,
*   currentness, or operation of this software, and all use is at your
*   own risk. Neither Amiga nor the authors assume any responsibility
*   or liability whatsoever with respect to your use of this software.
*

 **  IntegerExample.c -- Integer class Example.
 **
 **  This is a simple example testing some of the capabilities of the
 **  Integer gadget class.
 **
 **  This code opens a window and then creates 2 Integer gadgets which
 **  are subsequently attached to the window's gadget list.  One uses
 **  arrows, one does not.  Notice that you can tab cycle between them.
 **/

/* system includes
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include <exec/types.h>
#include <exec/memory.h>
#include <dos/dos.h>
#include <dos/dostags.h>
#include <intuition/intuition.h>
#include <intuition/gadgetclass.h>
#include <intuition/classes.h>
#include <intuition/icclass.h>
#include <intuition/cghooks.h>

#include <graphics/gfxbase.h>
#include <graphics/text.h>
#include <graphics/gfxmacros.h>
#include <utility/tagitem.h>
#include <workbench/startup.h>
#include <workbench/workbench.h>
#include <utility/hooks.h>

#include <libraries/asl.h>
#include <libraries/gadtools.h>
#include <libraries/diskfont.h>

#include <clib/reaction_lib_protos.h>
#include <clib/alib_protos.h>
#include <clib/icon_protos.h>

#include <clib/intuition_protos.h>
#include <inline/intuition.h>


#include <images/bitmap.h>


#include <proto/asl.h>
#include <proto/bitmap.h>
// #include <proto/intuition.h>

#include <proto/exec.h>

#include <proto/dos.h>
#include <proto/layout.h>
#include <proto/button.h>
#include <proto/window.h>
#include <proto/label.h>
#include <proto/listbrowser.h>
#include <proto/chooser.h>
#include <proto/slider.h>
#include <proto/diskfont.h>
//#include <proto/icon.h>

#include <gadgets/layout.h>
#include <gadgets/button.h>
#include <gadgets/listbrowser.h>
#include <gadgets/chooser.h>
#include <gadgets/slider.h>
//#include <gadgets/gradientslider.h>

#include <classes/window.h>
#include <images/label.h>

#include <reaction/reaction.h>
#include <reaction/reaction_macros.h>


#include "scsi_priv.h"
#include "EnumTypes.h"
#include "ListBrowser1.h"
#include "ListBrowser2.h"
#include "ListBrowser3.h"
#include "ListBrowser4.h"

#include "Chooser1.h"
// #include "Paper.h"

int main(void);

//struct Library *IconBase = NULL;

struct Library *BitMapBase = NULL;
struct Library *WindowBase = NULL;
struct Library *LayoutBase = NULL;
struct Library *LabelBase = NULL;
struct Library *ButtonBase = NULL;
struct Library *ListBrowserBase = NULL;
struct Library *PenMapBase = NULL;
struct Library *ChooserBase = NULL;
struct Library *SliderBase = NULL;
//struct Library *IntuitionBase = NULL;

T_MesPistes MesPistes[256];
UBYTE **MesTitres; 

UWORD topborder;

ULONG mapiste = 1;
int first_track;
int last_track;
int nb_pistes =0;
int current_track;
int current_pos;
int abs_pos;
int toclen;

ULONG MonVolume;

struct PistesInfo MesPistesInfo[256];


struct Screen *screen = NULL;
struct MsgPort *AppPort;
struct Window *windows[WID_LAST];
struct Gadget *gadgets[GID_LAST];
struct BitMap *Images;
struct List label_list;
struct List edito_list;
struct List *contenu_list;
struct List *fichier_list;
struct List *comment_list;
struct List chooser_list1;
struct DrawInfo *drinfo;


//struct TextAttr garnet16 = { (STRPTR)"Garnet.font", 32, 0, FPF_DISKFONT };
struct TextAttr helvetica15 = { (STRPTR)"Times.font", 15, 0, FPF_DISKFONT };
struct TextAttr helvetica20 = { (STRPTR)"Times.font", 25, 0, FPF_DISKFONT };
//struct TextAttr ATypewriter = { "American_Typewriter.font", 48, 0, FPF_DISKFONT};
struct TextAttr CGTimes = { "Times.font", 40, 0, FPF_DISKFONT }; //40

struct TextFont *Font1, *Font2, *Font3;

static struct IntuiText myIText0=
{
        3,1,
        JAM2,
        32,
        20,
        &CGTimes,
        "1",
        NULL
};

static struct IntuiText myIText1=
{
        4,1,
        JAM2,
        220,
        20,
        &helvetica20,
        "2",
        NULL
};

static struct IntuiText myIText2=
{
        5,1,
        JAM2,
        220,
        46,
        &helvetica15,
        "3",
        NULL
};




//char *p; //pointeur pour faire joli



BOOLEAN testinit=NULL;
extern BOOLEAN init(char *device, int number);
extern void motor (int motorstatus);
extern int read_toc (int toclong);
extern void set_volume (int vol0, int vol1, int vol2, int vol3);
extern void read_subchannel (BOOLEAN parsed, UBYTE subchannel, UBYTE subchannelformat, UBYTE track);

extern void play_from(int pos_deb, int pos_fin);

BOOL make_chooserlist(struct List *list, UBYTE **labels1);
VOID free_chooserlist(struct List *list);



extern void play_audio (int starttrack, int startindex, int endtrack, int endindex);

struct TimerDev {
	struct MsgPort *tport;
	BOOL close;
	long delay;
	long sig;
};

struct TimerDev *my_timer;

extern struct TimerDev *GoTimer(long timeunit);
extern void CloseTimer(struct TimerDev *td);

STRPTR IndexPath = "CD_Titles:";
static UBYTE cd[20];

BOOL
GetIndex( ULONG t, ULONG a1, ULONG a2 )
{
    UBYTE buf[256];
    BPTR f;
	 UBYTE Auteur[50];
	 UBYTE Titre[50];
	 int res;
	 int i;
    /* Read an index file from the disk */



for (i=0;i<=nb_pistes;i++)
	{
  	 free(MesTitres[i]);  // pose des probleme avec le chooser
	};
	free(MesTitres);
									
	MesTitres = NULL;
	
											
	if (res == 2) 
	{
		MesTitres = (UBYTE **) realloc(MesTitres, sizeof(UBYTE *));
		MesTitres[0] = (UBYTE *) malloc(50);
		strcpy(MesTitres[0],"Pas de CD insr !");
		MesTitres = (UBYTE **) realloc(MesTitres, (2) * sizeof(UBYTE *));
		MesTitres[1] = NULL;
		//cdin=FALSE;
	} else if (res == 1) 
	{
		MesTitres = (UBYTE **) realloc(MesTitres, sizeof(UBYTE *));
		MesTitres[0] = (UBYTE *) malloc(50);
		strcpy(MesTitres[0],"Pas de piste audio sur le CD !");
		MesTitres = (UBYTE **) realloc(MesTitres, (2) * sizeof(UBYTE *));
		MesTitres[1] = NULL;
		//cdin=FALSE;
	} else 
	{

    	strcpy( buf, IndexPath );
    	sprintf( cd, "ID%02.2ld%06.6lx%06.6lx", t, a1 , a2 );
    	AddPart( buf, cd, sizeof(buf)-1 );


    	if (f = Open(buf, MODE_OLDFILE))
    	{
      	//ULONG i;

        	FGets(f, buf, sizeof(buf)-1);
        	//strcpy(Auteur, buf);
        	FGets(f, buf, sizeof(buf)-1);
        	//strcpy(Titre, buf);

        	for (i = 0 ; i < t ; i++)
        	{
            FGets(f, buf, sizeof(buf)-1);
            MesTitres = (UBYTE **) realloc(MesTitres, (i+1) * sizeof(UBYTE *));
				MesTitres[i] = (UBYTE *) malloc(strlen(buf)+1);
            strncpy(MesTitres[i], buf,strlen(buf)-1);
        	}

			MesTitres[i] = NULL;
			
        Close(f);


       // return TRUE;

    	}else
    	{
    		for(i=0;i<=nb_pistes;i++)
			{
				MesTitres = (UBYTE **) realloc(MesTitres, (i+1) * sizeof(UBYTE *));
				MesTitres[i] = (UBYTE *) malloc(strlen(MesPistes[i+1].Nom)+1);
				strcpy(MesTitres[i],MesPistes[i+1].Nom);
			};
			
			//MesTitres = (UBYTE **) realloc(MesTitres, (i+1) * sizeof(UBYTE *));
			MesTitres[i-1] = NULL;
			//MesTitres[i+1] = NULL;	
    	}
	
   }

free_chooserlist (&chooser_list1);
make_chooserlist(&chooser_list1, MesTitres); 	
											
SetAttrs(gadgets[GID_CHOOSER1],
			CHOOSER_Labels, (ULONG)&chooser_list1,
			TAG_END);
											
RefreshGList(gadgets[GID_CHOOSER1],windows[WID_MAIN],NULL,GID_CHOOSER1);

return FALSE;
}

BOOL testcd(void)
{

//int i;
int res;
int OldTaille;

BOOL cdin=TRUE;
BOOL titreok;

OldTaille = MesPistesInfo[0].taille;

res = read_toc(1);

if (MesPistesInfo[0].taille != OldTaille)
{

titreok = GetIndex(nb_pistes, MesPistesInfo[3].deb-MesPistesInfo[0].deb,
			 MesPistesInfo[nb_pistes].deb + MesPistesInfo[nb_pistes].taille
			  - MesPistesInfo[0].deb);

	/*										
	for (i=0;i<=nb_pistes;i++)
	{
  	 free(MesTitres[i]);  // pose des probleme avec le chooser
	};
	free(MesTitres);
									
	MesTitres = NULL;
	
											
	if (res == 2) 
	{
		MesTitres = (UBYTE **) realloc(MesTitres, sizeof(UBYTE *));
		MesTitres[0] = (UBYTE *) malloc(50);
		strcpy(MesTitres[0],"Pas de CD insr !");
		MesTitres = (UBYTE **) realloc(MesTitres, (2) * sizeof(UBYTE *));
		MesTitres[1] = NULL;
		cdin=FALSE;
	} else if (res == 1) 
	{
		MesTitres = (UBYTE **) realloc(MesTitres, sizeof(UBYTE *));
		MesTitres[0] = (UBYTE *) malloc(50);
		strcpy(MesTitres[0],"Pas de piste audio sur le CD !");
		MesTitres = (UBYTE **) realloc(MesTitres, (2) * sizeof(UBYTE *));
		MesTitres[1] = NULL;
		cdin=FALSE;
	} else 
	{
		for(i=0;i<=nb_pistes;i++)
		{
			MesTitres = (UBYTE **) realloc(MesTitres, (i+1) * sizeof(UBYTE *));
			MesTitres[i] = (UBYTE *) malloc(strlen(MesPistes[i+1].Nom)+1);
			strcpy(MesTitres[i],MesPistes[i+1].Nom);
		};
			
		//MesTitres = (UBYTE **) realloc(MesTitres, (i+1) * sizeof(UBYTE *));
		MesTitres[i-1] = NULL;
		//MesTitres[i+1] = NULL;	
										
	}
	
free_chooserlist (&chooser_list1);
make_chooserlist(&chooser_list1, MesTitres); 	
											
SetAttrs(gadgets[GID_CHOOSER1],
			CHOOSER_Labels, (ULONG)&chooser_list1,
			TAG_END);
											
RefreshGList(gadgets[GID_CHOOSER1],windows[WID_MAIN],NULL,GID_CHOOSER1);
*/

}
return (cdin);
};
	

/*
void  IDCMPFunc(	 register __a0 struct Hook *Hook, //peut-etre vir -> utiliser le code ...
						 register __a2 Object *Window,
						 register __a1 struct IntuiMessage *Msg )
{

	if (Msg->Class == IDCMP_IDCMPUPDATE)
	{
		/* The notification might include one of the tags we want to look at...
		 */
		if      (GetTagData (GA_ID, 0, Msg->IAddress) == GID_CHOOSER1)
		{
			mapiste = GetTagData(CHOOSER_Active, 0, Msg->IAddress);
			
			play_audio(MesPistes[mapiste+1].No,1,last_track,1);
		}		
		
	}	

}
*/

void openlibs(void) 
{
	/* Open the classes - typically not required to be done manually.
	 * SAS/C or DICE AutoInit can do this for you if linked with the
	 * supplied reaction.lib
	 */
	
	
	WindowBase = (struct Library *)OpenLibrary("window.class",44);
	LayoutBase = (struct Library *)OpenLibrary("gadgets/layout.gadget",44);
	ButtonBase = (struct Library *)OpenLibrary("gadgets/button.gadget",44);
	ListBrowserBase = (struct Library *)OpenLibrary("gadgets/listbrowser.gadget",44);
   ChooserBase = (struct Library *)OpenLibrary("gadgets/chooser.gadget",44);
	SliderBase = (struct Library *)OpenLibrary("gadgets/slider.gadget",44);

	LabelBase  = (struct Library *)OpenLibrary("images/label.image",44);
	BitMapBase = (struct Library *)OpenLibrary("images/bitmap.image",44);
	//IntuitionBase = (struct Library *)OpenLibrary("intuition.library",44);

	Font1=OpenDiskFont(&CGTimes);
	Font2=OpenDiskFont(&helvetica15);
	Font3=OpenDiskFont(&helvetica20);
	
	}

void closelibs(void) 
{
	/* Close the classes.
	 */
	
	CloseFont(Font1);
	CloseFont(Font2);
	CloseFont(Font3); 
	 
	//CloseLibrary( IntuitionBase   ); 
	CloseLibrary( BitMapBase		);
	CloseLibrary( LabelBase       );
	
	CloseLibrary( SliderBase      );
	CloseLibrary( ChooserBase     );
	CloseLibrary( ListBrowserBase );
	CloseLibrary( ButtonBase      );
	CloseLibrary( LayoutBase      );
	CloseLibrary( WindowBase      );
	
	//CloseLibrary( IconBase        );
}

/*
void MyPrintIText(struct RastPort *RPort, struct TextFont *Font, 
						UBYTE PenA, UBYTE PenB, 
						short PosX, short PosY,
						 char *montext)
{
	//SetFont(RPort,Font);
	SetAPen(RPort,PenA);
	SetBPen(RPort,PenB);
	//SetDrMd(RPort,JAM2);	 
	Move(RPort, PosX, PosY);
	Text(montext, 11);
}	
*/

struct Node *node;
BOOL make_chooserlist(struct List *list, UBYTE **labels1)
{
//struct Node *node;
		
NewList(list);

	while (*labels1)
	{
		if (node = AllocChooserNode(   // <- Nb Colonnes
			CNA_Text, *labels1,
			TAG_DONE))
			{
				AddTail(list, node);
			}
			else
			break;
	labels1++;
	}
return(TRUE);
}		
																																																																																																																						
VOID free_chooserlist(struct List *list)
{
struct Node *node, *nextnode;
node = list->lh_Head;
	while (nextnode = node->ln_Succ)
	{
		FreeChooserNode(node);
		node = nextnode;
	}
NewList(list);
}




int main(void)
{
//   int vi;
//	struct Hook idcmphook;
	Object *objects[OID_LAST];

	//printf ("device %s, unit %i\n", device, unit);
	//              Virer le If si ca Marche pas ...
	if (device==NULL) device = "scsi.device";
	
	if ((unit>16)||(unit==NULL))
	{
		unit=2;
	}
	
	testinit = init (device,unit);

	/* make sure our classes opened... */
	openlibs();
	if ( !SliderBase || !ChooserBase || !ListBrowserBase || !ButtonBase || !WindowBase || !LayoutBase || !LabelBase) {
 		/*printf("A Library could not be opened\n");*/
		return(30);
	}	
	else if ( AppPort = CreateMsgPort() )
	{
		/* Create the window object.
		 */
		 
		
	 if (screen = LockPubScreen(NULL))
     {  
//		if ( (vi = GetVisualInfo(screen, TAG_END)))
//       {		
		 drinfo = GetScreenDrawInfo(screen);
		
		topborder=screen->WBorTop+(screen->Font->ta_YSize+1);
		
		idcmphook.h_Entry = (ULONG (* )(VOID))IDCMPFunc;
		idcmphook.h_SubEntry = NULL; 
		 
		make_chooserlist(&chooser_list1, CList1); 
		
		//chooser_list1 = ChooserLabelsA(CList1);
		//Images = NewObject( BITMAP_GetClass(), NULL,
		//	BITMAP_Screen, screen,
		//	BITMAP_SourceFile, (STRPTR) "ram:monfic.bsh",
		//TAG_END);	
				 
		objects[OID_MAIN] = NewObject( WINDOW_GetClass(), NULL,
			WA_ScreenTitle, "CD Player",
			WA_Title, "CD Player V0.8a by SixK",
			WA_Activate, TRUE,
			WA_DepthGadget, TRUE,
			WA_DragBar, TRUE,
			WA_CloseGadget, TRUE,
			//WA_SizeGadget, TRUE,
			//WA_Width, 650,
			//WA_Height, 150,
			WA_SmartRefresh, TRUE,
			//WA_NoCareRefresh, TRUE,
			WA_IDCMP, IDCMP_GADGETUP|IDCMP_GADGETDOWN|IDCMP_IDCMPUPDATE| BUTTONIDCMP | IDCMP_MOUSEMOVE,
			WINDOW_IconifyGadget, TRUE,
			WINDOW_IconTitle, "CD Player",
			WINDOW_AppPort, AppPort,
			WINDOW_Position, WPOS_CENTERMOUSE,
//			WINDOW_IDCMPHook, &idcmphook,	/* For BOOPSI notification */
//			WINDOW_IDCMPHookBits, IDCMP_IDCMPUPDATE,
			WINDOW_BackFillName, "ScsiPlay:skins/Label1.iff",
			WINDOW_ParentGroup, gadgets[GID_MAIN] = NewObject( LAYOUT_GetClass(), NULL, LAYOUT_Orientation, LAYOUT_ORIENT_VERT,
				ICA_TARGET, ICTARGET_IDCMP,
				LAYOUT_SpaceOuter, TRUE,
				LAYOUT_DeferLayout, TRUE,
				
				
				LAYOUT_AddChild, NewObject( LAYOUT_GetClass(), NULL,
				
				
					LAYOUT_AddChild, NewObject( LAYOUT_GetClass(), NULL, LAYOUT_Orientation, LAYOUT_ORIENT_VERT,
				
						
						LAYOUT_AddChild, NewObject( LAYOUT_GetClass(), NULL, LAYOUT_Orientation, LAYOUT_ORIENT_VERT,
						
						
								LAYOUT_BevelStyle, BVS_FIELD,
							
							
						  		LAYOUT_AddImage, gadgets[GID_LABEL1] = NewObject( LABEL_GetClass(), NULL,
						  			GA_ID, GID_LABEL1,
						  			GA_RelVerify, TRUE,
                  			LABEL_Image, (Object *) gadgets[GID_IMAGE20] = (Object *) NewObject( BITMAP_GetClass(), NULL,
                                 BITMAP_SourceFile, "ScsiPlay:skins/Label2.iff",
                                 BITMAP_Screen, screen,
                                 BITMAP_Precision, PRECISION_EXACT,
                           TAG_END), 
                  		TAG_END),
                  		
                  		CHILD_MinWidth, 522,//500
						TAG_END),
						
						
						
						LAYOUT_AddChild, NewObject( LAYOUT_GetClass(), NULL,
						LAYOUT_InnerSpacing, 5,						
						
							LAYOUT_AddChild, NewObject( LAYOUT_GetClass(), NULL,
							 
							LAYOUT_InnerSpacing, 1,
							
								LAYOUT_AddChild, gadgets[GID_BUTTON5] = NewObject( NULL, "button.gadget",
									GA_ID, GID_BUTTON5,
									GA_TabCycle, TRUE,
									GA_RelVerify, TRUE,
									GA_Text, "|<<",
									BUTTON_Transparent, TRUE,
									BUTTON_RenderImage, (Object *) gadgets[GID_IMAGE1] = (Object *) NewObject( BITMAP_GetClass(), NULL,
                                 BITMAP_SourceFile, "ScsiPlay:skins/BackTrack.iff",
                                 BITMAP_Screen, screen,
                                 BITMAP_Precision, PRECISION_EXACT,
                           TAG_END),
                           BUTTON_SelectImage, (Object *) gadgets[GID_IMAGE2] = (Object *) NewObject( BITMAP_GetClass(), NULL,
                                 BITMAP_SourceFile, "ScsiPlay:skins/BackTrack2.iff",
                                 BITMAP_Screen, screen,
                                 BITMAP_Precision, PRECISION_EXACT,
                           TAG_END),
								TAG_END),
								
								LAYOUT_AddChild, gadgets[GID_BUTTON6] = NewObject( NULL, "button.gadget",
									GA_ID, GID_BUTTON6,
									GA_TabCycle, TRUE,
									GA_RelVerify, TRUE,
									GA_Text, "<<",
									GA_Immediate, TRUE,
									BUTTON_Transparent, TRUE,
									BUTTON_RenderImage, (Object *) gadgets[GID_IMAGE3] = (Object *) NewObject( BITMAP_GetClass(), NULL,
                                 BITMAP_SourceFile, "ScsiPlay:skins/FastBackward.iff",
                                 BITMAP_Screen, screen,
                                 BITMAP_Precision, PRECISION_EXACT,
                           TAG_END),
                           BUTTON_SelectImage, (Object *) gadgets[GID_IMAGE4] = (Object *) NewObject( BITMAP_GetClass(), NULL,
                                 BITMAP_SourceFile, "ScsiPlay:skins/FastBackward2.iff",
                                 BITMAP_Screen, screen,
                                 BITMAP_Precision, PRECISION_EXACT,
                           TAG_END),
								TAG_END),
								
								LAYOUT_AddChild, gadgets[GID_BUTTON1] = NewObject( NULL, "button.gadget",
									GA_ID, GID_BUTTON1,
									GA_TabCycle, TRUE,
									GA_RelVerify, TRUE,
									GA_Text, ">",
									BUTTON_BitMap, Images,
									BUTTON_Transparent, TRUE,
									BUTTON_RenderImage, (Object *) gadgets[GID_IMAGE5] = (Object *) NewObject( BITMAP_GetClass(), NULL,
                                 BITMAP_SourceFile, "ScsiPlay:skins/Play.iff",
                                 BITMAP_Screen, screen,
                                 BITMAP_Precision, PRECISION_EXACT,
                           TAG_END),
                           BUTTON_SelectImage, (Object *) gadgets[GID_IMAGE6] = (Object *) NewObject( BITMAP_GetClass(), NULL,
                                 BITMAP_SourceFile, "ScsiPlay:skins/Play2.iff",
                                 BITMAP_Screen, screen,
                                 BITMAP_Precision, PRECISION_EXACT,
                           TAG_END),
								TAG_END),
						
								LAYOUT_AddChild, gadgets[GID_BUTTON7] = NewObject( NULL, "button.gadget",
									GA_ID, GID_BUTTON7,
									GA_TabCycle, TRUE,
									GA_RelVerify, TRUE,
									GA_Immediate, TRUE,
									GA_Text, ">>",
									BUTTON_Transparent, TRUE,
									BUTTON_RenderImage, (Object *) gadgets[GID_IMAGE7] = (Object *) NewObject( BITMAP_GetClass(), NULL,
                                 BITMAP_SourceFile, "ScsiPlay:skins/FastForward.iff",
                                 BITMAP_Screen, screen,
                                 BITMAP_Precision, PRECISION_EXACT,
                           TAG_END),
                           BUTTON_SelectImage, (Object *) gadgets[GID_IMAGE8] = (Object *) NewObject( BITMAP_GetClass(), NULL,
                                 BITMAP_SourceFile, "ScsiPlay:skins/FastForward2.iff",
                                 BITMAP_Screen, screen,
                                 BITMAP_Precision, PRECISION_EXACT,
                           TAG_END),
								TAG_END),
							
								LAYOUT_AddChild, gadgets[GID_BUTTON8] = NewObject( NULL, "button.gadget",
									GA_ID, GID_BUTTON8,
									GA_TabCycle, TRUE,
									GA_RelVerify, TRUE,
									GA_Text, ">>|",
									BUTTON_Transparent, TRUE,
									BUTTON_RenderImage, (Object *) gadgets[GID_IMAGE9] = (Object *) NewObject( BITMAP_GetClass(), NULL,
                                 BITMAP_SourceFile, "ScsiPlay:skins/NextTrack.iff",
                                 BITMAP_Screen, screen,
                                 BITMAP_Precision, PRECISION_EXACT,
                           TAG_END),
                           BUTTON_SelectImage, (Object *) gadgets[GID_IMAGE10] = (Object *) NewObject( BITMAP_GetClass(), NULL,
                                 BITMAP_SourceFile, "ScsiPlay:skins/NextTrack2.iff",
                                 BITMAP_Screen, screen,
                                 BITMAP_Precision, PRECISION_EXACT,
                           TAG_END),
								TAG_END),
																
							TAG_END),
							CHILD_MinWidth, 260,
							CHILD_MaxWidth, 260,
							CHILD_MinHeight, 20,
							CHILD_MaxHeight, 20,	
							
							LAYOUT_AddChild, NewObject( LAYOUT_GetClass(), NULL,
							LAYOUT_InnerSpacing, 1,

								LAYOUT_AddChild, gadgets[GID_BUTTON2] = NewObject( NULL, "button.gadget",
									GA_ID, GID_BUTTON2,
									GA_TabCycle, TRUE,
									GA_RelVerify, TRUE,
									GA_Text, "||",
									BUTTON_Transparent, TRUE,
									BUTTON_RenderImage, (Object *) gadgets[GID_IMAGE11] = (Object *) NewObject( BITMAP_GetClass(), NULL,
                                 BITMAP_SourceFile, "ScsiPlay:skins/Pause.iff",
                                 BITMAP_Screen, screen,
                                 BITMAP_Precision, PRECISION_EXACT,
                           TAG_END),
                           BUTTON_SelectImage, (Object *) gadgets[GID_IMAGE12] = (Object *) NewObject( BITMAP_GetClass(), NULL,
                                 BITMAP_SourceFile, "ScsiPlay:skins/Pause2.iff",
                                 BITMAP_Screen, screen,
                                 BITMAP_Precision, PRECISION_EXACT,
                           TAG_END),
								TAG_END),
												
								LAYOUT_AddChild, gadgets[GID_BUTTON3] = NewObject( NULL, "button.gadget",
									GA_ID, GID_BUTTON3,
									GA_TabCycle, TRUE,
									GA_RelVerify, TRUE,
									GA_Text, "#",
									BUTTON_Transparent, TRUE,
									BUTTON_RenderImage, (Object *) gadgets[GID_IMAGE13] = (Object *) NewObject( BITMAP_GetClass(), NULL,
                                 BITMAP_SourceFile, "ScsiPlay:skins/Stop.iff",
                                 BITMAP_Screen, screen,
                                 BITMAP_Precision, PRECISION_EXACT,
                           TAG_END),
                           BUTTON_SelectImage, (Object *) gadgets[GID_IMAGE14] = (Object *) NewObject( BITMAP_GetClass(), NULL,
                                 BITMAP_SourceFile, "ScsiPlay:skins/Stop2.iff",
                                 BITMAP_Screen, screen,
                                 BITMAP_Precision, PRECISION_EXACT,
                           TAG_END),
								TAG_END),
							
							TAG_END),
							CHILD_MinWidth, 102,
							CHILD_MaxWidth, 102,					
							CHILD_MinHeight, 20,
							CHILD_MaxHeight, 20,		
							
							LAYOUT_AddChild, NewObject( LAYOUT_GetClass(), NULL,
							
								LAYOUT_AddChild, gadgets[GID_BUTTON4] = NewObject( NULL, "button.gadget",
									GA_ID, GID_BUTTON4,
									GA_TabCycle, TRUE,
									GA_RelVerify, TRUE,
									GA_Text, "Eject",
									BUTTON_Transparent, TRUE,
									BUTTON_RenderImage, (Object *) gadgets[GID_IMAGE15] = (Object *) NewObject( BITMAP_GetClass(), NULL,
                                 BITMAP_SourceFile, "ScsiPlay:skins/Eject.iff",
                                 BITMAP_Screen, screen,
                                 BITMAP_Precision, PRECISION_EXACT,
                           TAG_END),
                           BUTTON_SelectImage, (Object *) gadgets[GID_IMAGE16] = (Object *) NewObject( BITMAP_GetClass(), NULL,
                                 BITMAP_SourceFile, "ScsiPlay:skins/Eject2.iff",
                                 BITMAP_Screen, screen,
                                 BITMAP_Precision, PRECISION_EXACT,
                           TAG_END),
								TAG_END),
								CHILD_MaxWidth, 50,
								CHILD_MinWidth, 50,
							
							TAG_END),
							CHILD_MinWidth, 52,
							CHILD_MaxWidth, 52,					
							CHILD_MinHeight, 20,
							CHILD_MaxHeight, 20,	
					//	TAG_END),
						
						
					//	LAYOUT_AddChild, NewObject( LAYOUT_GetClass(), NULL,
						 
	
								
						
						TAG_END),
						
						
				
				
						LAYOUT_AddChild, NewObject( LAYOUT_GetClass(), NULL, LAYOUT_Orientation, LAYOUT_ORIENT_VERT,
						LAYOUT_InnerSpacing, 5,
						LAYOUT_TopSpacing, 2,
							LAYOUT_AddChild, NewObject( CHOOSER_GetClass(), NULL,
								GA_ID, GID_CHOOSER1,
								GA_TabCycle, TRUE,
								GA_RelVerify, TRUE,
								GA_Text, "Choisissez la Piste ",
								CHOOSER_Labels, (ULONG)&chooser_list1,
								//CHOOSER_PopUp, TRUE,
								ICA_TARGET, ICTARGET_IDCMP,
								CHOOSER_DropDown, TRUE,
								CHOOSER_MaxLabels,99,
							TAG_END),
					
						
							LAYOUT_AddChild, NewObject( SLIDER_GetClass(), NULL,
								GA_ID, GID_SLIDER2,
								GA_RelVerify, TRUE,
								//GA_Text, "Balance",
								SLIDER_Min, 0,
								SLIDER_Max, 200,
								SLIDER_Level, 100,
								SLIDER_Orientation, SLIDER_HORIZONTAL,
								SLIDER_ShortTicks, TRUE,
								SLIDER_Ticks, 25,
								SLIDER_TickSize, 8,
								//SLIDER_BodyImage, (Object *) gadgets[GID_IMAGE24] = (Object *) NewObject( BITMAP_GetClass(), NULL,
                        //   BITMAP_SourceFile, "ScsiPlay:MonSlider2.iff",
                        //   BITMAP_Screen, screen,
                        //   BITMAP_Precision, PRECISION_EXACT,
                     	//TAG_END),
								SLIDER_KnobImage, (Object *) gadgets[GID_IMAGE23] = (Object *) NewObject( BITMAP_GetClass(), NULL,
                           BITMAP_SourceFile, "ScsiPlay:skins/Scroll2.iff",
                           BITMAP_Screen, screen,
                           BITMAP_Precision, PRECISION_EXACT,
                     	TAG_END),
                     	
							TAG_END),
							
							LAYOUT_BottomSpacing, 2,
							LAYOUT_LeftSpacing, 1,
							LAYOUT_RightSpacing, 2,
							
							LAYOUT_AddChild, NewObject( NULL, "button.gadget",
								GA_ID, GID_QUIT,
								GA_RelVerify, TRUE,
								GA_Text,"_Quit",
								BUTTON_RenderImage, (Object *) gadgets[GID_IMAGE17] = (Object *) NewObject( BITMAP_GetClass(), NULL,
                              BITMAP_SourceFile, "ScsiPlay:skins/Quit3.iff",
                              BITMAP_Screen, screen,
                              BITMAP_Precision, PRECISION_EXACT,
                        TAG_END),
                        BUTTON_SelectImage, (Object *) gadgets[GID_IMAGE18] = (Object *) NewObject( BITMAP_GetClass(), NULL,
                              BITMAP_SourceFile, "ScsiPlay:skins/Quit4.iff",
                              BITMAP_Screen, screen,
                              BITMAP_Precision, PRECISION_EXACT,
                        TAG_END),
							TAG_END),
							
						TAG_END),
					
					TAG_END),

					LAYOUT_AddChild, NewObject( LAYOUT_GetClass(), NULL,
					LAYOUT_TopSpacing,5,
						LAYOUT_AddChild, NewObject( SLIDER_GetClass(), NULL,
							GA_ID, GID_SLIDER1,
							GA_RelVerify, TRUE,
							//GA_Text, "Volume",
							//GA_Height, 200,
							SLIDER_Orientation, SLIDER_VERTICAL,
							SLIDER_Min, 0,
							SLIDER_Max, 255,
							SLIDER_Level, 255,
							SLIDER_Invert, TRUE,
							SLIDER_Ticks, 25,
							SLIDER_TickSize, 10,
							SLIDER_ShortTicks, FALSE,		
							SLIDER_KnobImage, (Object *) gadgets[GID_IMAGE22] = (Object *) NewObject( BITMAP_GetClass(), NULL,
                           BITMAP_SourceFile, "ScsiPlay:skins/Scroll1.iff",
                           BITMAP_Screen, screen,
                           BITMAP_Precision, PRECISION_EXACT,
                     TAG_END),
                     //SLIDER_BodyImage, (Object *) gadgets[GID_IMAGE25] = (Object *) NewObject( BITMAP_GetClass(), NULL,
                     //      BITMAP_SourceFile, "ScsiPlay:MonSlider1.iff",
                     //      BITMAP_Screen, screen,
                     //      BITMAP_Precision, PRECISION_EXACT,
                     //TAG_END),
						TAG_END),
					TAG_END),
				TAG_END),
			TAG_END),
		TAG_END);

	 	/*  Object creation sucessful?
	 	 */
		if (objects[OID_MAIN])
		{
			/*  Open the window.
			 */
			if (windows[WID_MAIN] = (struct Window *) RA_OpenWindow(objects[OID_MAIN]))
			{
				ULONG wait, signal, app = (1L << AppPort->mp_SigBit);
				ULONG done = FALSE;
				ULONG result;
				UWORD code;
				//ULONG MonItem;
				//ULONG MonFich;
				//ULONG MaDst2;
				ULONG MonVolume= 0;
				ULONG fast_re;
				ULONG fast_fo;
				
				static int curr_min;
				static int curr_sec;
				static int remain_min;
				static int remain_sec;
				static int tot_min;
				static int tot_sec;
				static int tot_remain_min;
				static int tot_remain_sec;
				static int track_min;
				static int track_sec;
				int oldtrack;
				int oldpos = 0;				
				BOOL win_open = TRUE; 
				BOOL cd_in = FALSE;
				
				int new_pos;
				
				int motor_state = -1;	
				int eject_state = -1;
				int pause_state = 0;	
				int pause_pos;		
				
				int v_d= 255;
				int v_g= 255;
				int v_i= 255;
				int i_dg = 100;
				
				
				
			 	/* Obtain the window wait signal mask.
				 */
				GetAttr(WINDOW_SigMask, objects[OID_MAIN], &signal);
				
				my_timer=GoTimer(2);

				while (!done)
				{
				
				wait = Wait( signal | my_timer->sig );
				
				
				  
					if ( (win_open==TRUE) && (wait == my_timer->sig) )
					{	//test si la fenetre est ouverte ou iconifie
						
						//if (cd_in == FALSE) 
						//{
							cd_in=testcd();
						//}
						
						read_subchannel (TRUE, 64, 1, 0);

						//current_pos = current_pos + toclen; //test avec Toc
						
						if ((current_pos<oldpos) && (oldtrack==current_track) && (current_pos < 150))
						{
							current_pos = oldpos;
						}	
						
						oldtrack = current_track;
						oldpos = current_pos;
						 	
						curr_min = (current_pos) / 75 / 60;
						curr_sec = (current_pos / 75) % 60;
					
					
						remain_min = (MesPistesInfo[current_track].taille - (current_pos)) / 75 / 60;
						remain_sec = ((MesPistesInfo[current_track].taille - (current_pos)) / 75)% 60; 
					
						track_min = MesPistesInfo[current_track].taille / 75 / 60;
						track_sec = (MesPistesInfo[current_track].taille/ 75)% 60;
					
						tot_min = (abs_pos ) / 75/60; //2 * la toc
						tot_sec = ((abs_pos ) /75)%60;
					
						tot_remain_min = (MesPistesInfo[0].taille  - abs_pos ) /75 /60;
						tot_remain_sec = ((MesPistesInfo[0].taille - abs_pos )/75)%60;
					
										
						sprintf(myIText0.IText, "%2.2d   %2.2d:%2.2d  ",
									current_track, curr_min, curr_sec
								 );
						SetAPen(windows[WID_MAIN]->RPort,3);
						SetBPen(windows[WID_MAIN]->RPort,1);
						SetDrMd(windows[WID_MAIN]->RPort,JAM2);	 
						Move(windows[WID_MAIN]->RPort,32,topborder-12+48);
						SetFont(windows[WID_MAIN]->RPort,Font1);
						Text(windows[WID_MAIN]->RPort,myIText0.IText, 11);
					
						//MyPrintIText(windows[WID_MAIN]->RPort, Font1, 3, 1, 32, 46, myIText0.IText);
					
						sprintf(myIText1.IText, "remain: %2.2d:%2.2d  len: %2.2d:%2.2d   "
					   	    , remain_min, remain_sec, track_min, track_sec
					      	 );
						Move(windows[WID_MAIN]->RPort,220,topborder-12+36);
						SetFont(windows[WID_MAIN]->RPort,Font3);
						SetAPen(windows[WID_MAIN]->RPort,22);
						Text(windows[WID_MAIN]->RPort,myIText1.IText, 28);
					
						sprintf(myIText2.IText, "abs_pos: %2.2d:%2.2d  tot_remain: %2.2d:%2.2d  tot_len: %2.2d:%2.2d   "
					   	    , tot_min, tot_sec, tot_remain_min, tot_remain_sec
					      	 , MesPistesInfo[0].minutes, MesPistesInfo[0].secondes);
					       
						Move(windows[WID_MAIN]->RPort,220,topborder-12+60);
						SetFont(windows[WID_MAIN]->RPort,Font2);
						SetAPen(windows[WID_MAIN]->RPort,22);
					   Text(windows[WID_MAIN]->RPort,myIText2.IText, 50);
					

						GetAttr( GA_Selected, gadgets[GID_BUTTON6], &fast_re);					
						GetAttr( GA_Selected, gadgets[GID_BUTTON7], &fast_fo);
					
						if (fast_re && (abs_pos > 0)) {
							new_pos = abs_pos - 525;
							
							if (new_pos < MesPistesInfo[first_track].deb) {
								new_pos = MesPistesInfo[first_track].deb;
							}
							if (new_pos<toclen) new_pos = toclen; // 150 toc
							play_from (new_pos, MesPistesInfo[last_track].fin);
						}

						if (fast_fo && (abs_pos > 0)) {
							new_pos = abs_pos + 525;
							if (new_pos > MesPistesInfo[last_track].fin) {
								new_pos = MesPistesInfo[last_track].fin;
							}
							play_from (new_pos, MesPistesInfo[last_track].fin);
						}
       			} // endif win

					if ( wait & SIGBREAKF_CTRL_C )
					{
						done = TRUE;
					}
					else
					{
					
					
						while ( (result = RA_HandleInput(objects[OID_MAIN], &code) ) != WMHI_LASTMSG )
						{
						
							switch (result & WMHI_CLASSMASK)
							{
								case WMHI_CLOSEWINDOW:
									windows[WID_MAIN] = NULL;
									done = TRUE;
									break;

								case WMHI_GADGETUP:
									switch (result & WMHI_GADGETMASK)
									{
		
										case GID_BUTTON1:  // play
											//cd_in=testcd();
											play_audio(MesPistes[1].No,1,MesPistes[last_track].No,1);
											break;

										case GID_BUTTON2:  // pause 										
										
											if (pause_state == 0)
												{
													pause_pos = current_pos;
													motor(0);
													pause_state = 1;
												} 
											else
												{
													play_from (pause_pos + toclen, MesPistesInfo[last_track].fin);
													pause_state = 0;
												};
										
											break;	
									
										case GID_BUTTON3:  // stop
											motor(0);  // modifs  apporter avec la pause
											break;
										
										case GID_BUTTON4:  // eject
											if (eject_state == 0)
												{
													eject_state = 1;
													//cd_in=FALSE;
												}
											else
												{
													eject_state = 0;
													//cd_in=FALSE;
												};
											motor(eject_state | 2);
											break;
										
										case GID_BUTTON5:  //prev track
											if (MesPistes[current_track].No > MesPistes[1].No)
											   {
											   	current_track -= 1;
													play_audio(MesPistes[current_track].No,1,MesPistes[last_track].No,1);
											   }
											
											break;
										
											
										case GID_BUTTON8:	
											if (MesPistes[current_track].No < MesPistes[last_track].No)
											   {
											   	current_track += 1;
													play_audio(MesPistes[current_track].No,1,MesPistes[last_track].No,1);
											   }
											
											break;
										
										
										case GID_CHOOSER1:
											break;
										
										case GID_SLIDER1:
											v_i = code;
											v_d = v_i-(255 * (100 - i_dg) / 100); 
											v_g = v_i-(255 * (i_dg - 100) / 100);
											
											if (v_g > 255) {v_g = 255;};
											if (v_d > 255) {v_d = 255;};
											
											set_volume(v_g, v_d, 0, 0);
											break;
										
										
										case GID_SLIDER2:
											
											i_dg = code;		
											
											
											v_d= v_i-(255 * (100 - i_dg) / 100);
											v_g= v_i-(255 * (i_dg - 100) / 100);
											if (v_g > 255) {v_g = 255;};
											if (v_d > 255) {v_d = 255;};
											
											set_volume(v_g, v_d, 0, 0); 
											break;
										
										case GID_QUIT:
											done = TRUE;
											break;
									}
									break;
									
								
							
								case WMHI_ICONIFY:
									RA_Iconify(objects[OID_MAIN]);
								   windows[WID_MAIN] = NULL;
									win_open = FALSE;
									break;

								case WMHI_UNICONIFY:
									windows[WID_MAIN] = (struct Window *) RA_OpenWindow(objects[OID_MAIN]);

									if (windows[WID_MAIN])
									{
										GetAttr(WINDOW_SigMask, objects[OID_MAIN], &signal);
										win_open = TRUE;
									}
									else
									{
										done = TRUE;	// error re-opening window!
									}
								 	break;
							} //switch (result & WMHI_GADGETMASK) 
						}//switch (result & WMHI_CLASSMASK) 
					} //while ( (result = RA_HandleInput(objects[OID_MAIN], &code) ) != WMHI_LASTMSG ) 
				}
			}

			/* Disposing of the window object will also close the window if it is
			 * already opened, and it will dispose of the layout object attached to it.
			 */
			DisposeObject(objects[OID_MAIN]);
		}
	//	 FreeVisualInfo(vi);
   //   }
      FreeScreenDrawInfo (screen,drinfo);
	 }
    UnlockPubScreen(0, screen); 

	 DeleteMsgPort(AppPort);
	}
   
   free_chooserlist (&chooser_list1);
   
	//DisposeObject(objects[OID_MAIN]);
	
	if(my_timer) CloseTimer(my_timer);
	
	closelibs();
	return(0);
}

/*
void wbmain(struct WBStartup * argmsg)
{
    struct WBArg *wb_arg;
    LONG i;
    BPTR olddir;
    //char *AppName;
   
    char *s;
    char *device;
	 STRPTR *toolarray;
    int unit;
    
    struct DiskObject *dobj;
    
        wb_arg = argmsg->sm_ArgList ;         /* head of the arg list */
        
        
        //for (i = 0; i < argmsg->sm_NumArgs; i++, wb_arg++) {
            if (wb_arg->wa_Lock) {
                /* locks supported, change to the proper directory */
                olddir = CurrentDir(wb_arg->wa_Lock) ;

                /* process the file.
                ** If you have done the CurrentDir() above, then you can
                ** access the file by its name.  Otherwise, you have to
                ** examine the lock to get a complete path to the file.
                */
					//if  ( GetProgramName(AppName, 127))
					//	   {
					//	   }
					
					if ( ( dobj = GetDiskObject( wb_arg->wa_Name ) ) )
						{
					//	Printf("nom : %s\n", wb_arg->wa_Name);
							toolarray = (STRPTR *)dobj->do_ToolTypes;
						
						if  ( device = FindToolType( toolarray, "DEVICE" ) ) 
							{
							}
						
						if  ( s = FindToolType( toolarray, "UNIT" ) ) 
							{
								unit = atoi( s );
							}
						
					}
					

                /* change back to the original directory when done.
                ** be sure to change back before you exit.
                */
                CurrentDir(olddir) ;
            } else {
                /* something that does not support locks */
            }
        //}
  i = main (device,unit);  
}
*/