#ifndef MAKE_ID
#define MAKE_ID(a,b,c,d) ((ULONG) (a)<<24 | (ULONG) (b)<<16 | (ULONG) (c)<<8 | (ULONG) (d))
#endif

#ifdef _DCC
#define __inline
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
// #include <libraries/dos.h>
#include <clib/dos_protos.h>
#include "interface.h"


struct T_MesPistes MesPistes[256];
UBYTE **MesTitres; 

UWORD topborder;

int mapiste = 1;
int first_track;
int last_track;
int nb_pistes =0;
int current_track;
int current_pos;
int abs_pos;
int toclen;

ULONG MonVolume;

struct PistesInfo MesPistesInfo[256];



struct Library *MUIMasterBase = NULL;
struct Library *IntuitionBase = NULL;
struct ObjApp *myapp=NULL;

struct Scsi {
        int unit;
        char device[32];
} scsi;

extern BOOL init(char *device, int number);
extern void inquiry (BOOL parsedoutput);
extern void deinitscsi(void);
extern void play_audio (int starttrack, int endtrack);
extern void play_audio_scsi12 (long starttrack, long endtrack);
extern int  read_toc (int toclong);
extern void motor (int motorstatus);
extern void read_subchannel (BOOLEAN parsed, UBYTE subchannel, UBYTE subchannelformat, UBYTE track);
extern void play_from(int pos_deb, int pos_fin);

STRPTR IndexPath = "CD_Titles:";
static UBYTE cd[20];

struct Data {

	/* background randomizer input handler
	 */
	ULONG bgrandom_timer_count;
	ULONG bgrandom_timer_wait;

	ULONG bgrandom_inputhandler_added;
	struct MUI_InputHandlerNode bgrandom_ihnode;

	/* cache cleanup counter
	 */
	ULONG cachecleanup_timer_count;
	ULONG cachecleanup_timer_wait;

	ULONG cachecleanup_inputhandler_added;
	struct MUI_InputHandlerNode cachecleanup_ihnode;

};


DEFNEW
{
	struct Data *data;

	obj = DoSuperNew(cl, obj,
		MUIA_Application_Title,       APPNAME,
		MUIA_Application_Version,     "$VER: "APPNAME" "LVERTAG,
		MUIA_Application_Copyright,   " 2001-2005 by David Gerber,  2005-" COPYRIGHTYEAR_END " by Ambient Open Source Team, All Rights Reserved.",
		MUIA_Application_Author,      "David Gerber, Ambient Open Source Team",
		MUIA_Application_UsedClasses, classlist,
		MUIA_Application_Description, "The MorphOS desktop",
		MUIA_Application_Base,        "AMBIENT",
		MUIA_Application_SingleTask,  TRUE,
		MUIA_Application_UseRexx,     FALSE,
		MUIA_Application_NoIconify,   TRUE,
		TAG_MORE, INITTAGS
	);

	if (!obj)
	{
		return (0);
	}

	data = INST_DATA(cl, obj);


//   ...


	/* cache cleanup handler (invoke cleanup routine every 30 minutes) */

	data->cachecleanup_timer_count = 30;
	data->cachecleanup_timer_wait = 30;

	data->cachecleanup_ihnode.ihn_Object = obj;
	data->cachecleanup_ihnode.ihn_Flags = MUIIHNF_TIMER;
	data->cachecleanup_ihnode.ihn_Millis = 100;
	data->cachecleanup_ihnode.ihn_Method = MM_Application_CleanupCache;
	DoMethod(obj, MUIM_Application_AddInputHandler, &data->cachecleanup_ihnode);
	data->cachecleanup_inputhandler_added = TRUE;

	return ((ULONG)obj);
}


DEFDISP
{
	GETDATA;


	if(data->bgrandom_inputhandler_added)
	{
		DoMethod(obj, MUIM_Application_RemInputHandler, &data->bgrandom_ihnode);
	}

	if(data->cachecleanup_inputhandler_added)
	{
		DoMethod(obj, MUIM_Application_RemInputHandler, &data->cachecleanup_ihnode);
	}


	return (DOSUPER);
}


DEFGET
{
}

DEFSET
{
	GETDATA;

	FORTAG(INITTAGS)
	{
       // ...

		case MA_Application_BackgroundRefreshDelay:
		{
			if(data->bgrandom_inputhandler_added)
			{
				DoMethod(obj, MUIM_Application_RemInputHandler, &data->bgrandom_ihnode);
				data->bgrandom_inputhandler_added = FALSE;
			}

			if(tag->ti_Data)
			{
				data->bgrandom_timer_wait = data->bgrandom_timer_count = (ULONG)tag->ti_Data;

				data->bgrandom_ihnode.ihn_Object = obj;
				data->bgrandom_ihnode.ihn_Flags = MUIIHNF_TIMER;
				data->bgrandom_ihnode.ihn_Millis = 100;
				data->bgrandom_ihnode.ihn_Method = MM_Application_ReloadBackgrounds;

				DoMethod(obj, MUIM_Application_AddInputHandler, &data->bgrandom_ihnode);

				data->bgrandom_inputhandler_added = TRUE;

			}
		}
	}
	NEXTTAG

	return (DOSUPER);
}

DEFTMETHOD(Application_CleanupCache)
{
	GETDATA;

	if(--data->cachecleanup_timer_count == 0)
	{
		data->cachecleanup_timer_count = data->cachecleanup_timer_wait;

		/*
		 * TODO: Make this one asynchronous? Probably good idea...
		 */

		cache_deleteunused();

	}

	return (0);
}

/* ---------------------------------------------------------------------------------------------------*/

HOOKPROTONH(PlayCD, ULONG, APTR obj, struct TagItem *tag_list)
{
          
        printf("Let's play !!!\n");

		  printf("piste : %d, last track : %d\n", mapiste, last_track);

		  play_audio_scsi12(MesPistesInfo[mapiste].deb, MesPistesInfo[0].taille);
//		  play_audio(MesPistesInfo[mapiste].deb, MesPistesInfo[0].taille);
//		  play_audio_ti(2,1,3,3);
//		  play_audio_scsi12(14000, 40000);

//		  play_from(15000, 20000);

		  //play_audio_scsi12(0, MesPistesInfo[0].taille);

        return TRUE;
}

MakeStaticHook(hook_PlayCD, PlayCD);

HOOKPROTONH(FastBackward, ULONG, APTR obj, struct TagItem *tag_list)
{
          
        printf("Let's play !!!\n");

		  printf("piste : %d, last track : %d\n", mapiste, last_track);

//		  play_audio_scsi12(MesPistesInfo[mapiste].deb, MesPistesInfo[0].taille);

		  play_from(abs_pos - 5, MesPistesInfo[0].taille);

		  //play_audio_scsi12(0, MesPistesInfo[0].taille);

        return TRUE;
}

MakeStaticHook(hook_FastBackward, FastBackward);


HOOKPROTONH(FastForward, ULONG, APTR obj, struct TagItem *tag_list)
{
          
        printf("Let's play !!!\n");

		  printf("piste : %d, last track : %d\n", mapiste, last_track);

//		  play_audio_scsi12(MesPistesInfo[mapiste].deb, MesPistesInfo[0].taille);

		  play_from(abs_pos + 5, MesPistesInfo[0].taille);

		  //play_audio_scsi12(0, MesPistesInfo[0].taille);

        return TRUE;
}

MakeStaticHook(hook_FastForward, FastForward);


HOOKPROTONH(NextTrack, ULONG, APTR obj, struct TagItem *tag_list)
{
          
        printf("Let's play !!!\n");

		  printf("piste : %d, last track : %d\n", MesPistes[mapiste+1].No, last_track);

		  mapiste = mapiste + 1;

		  // play_audio_scsi12(MesPistesInfo[mapiste].deb, MesPistesInfo[0].taille-MesPistesInfo[mapiste].deb);
			play_audio_scsi12(MesPistesInfo[mapiste].deb, MesPistesInfo[nb_pistes].fin-MesPistesInfo[mapiste].deb);

        return TRUE;
}

MakeStaticHook(hook_NextTrack, NextTrack);

HOOKPROTONH(PrevTrack, ULONG, APTR obj, struct TagItem *tag_list)
{
          
        printf("Let's play !!!\n");

		  printf("piste : %d, last track : %d\n", MesPistes[mapiste+1].No, last_track);

		  mapiste = mapiste - 1;

		  play_audio_scsi12(MesPistesInfo[mapiste].deb, MesPistesInfo[nb_pistes].fin-MesPistesInfo[mapiste].deb);

		  // play_audio_scsi12(MesPistesInfo[mapiste].deb, MesPistesInfo[0].taille-MesPistesInfo[mapiste].deb);

        return TRUE;
}

MakeStaticHook(hook_PrevTrack, PrevTrack);


BOOL
GetIndex( int t, ULONG a1, ULONG a2 )
{
    UBYTE buf[256];
    BPTR f;
	 UBYTE Auteur[50];
	 UBYTE Titre[50];
	 int res=0;
	 int i;
    /* Read an index file from the disk */


/*
for (i=0;i<=nb_pistes;i++)
	{
  	 free(MesTitres[i]);  // pose des probleme avec le chooser
	};
	free(MesTitres);
									
	MesTitres = NULL;
*/	
											
	if (res == 2) 
	{
		MesTitres = (UBYTE **) realloc(MesTitres, sizeof(UBYTE *));
		MesTitres[0] = (UBYTE *) malloc(50);
		strcpy(MesTitres[0],"Pas de CD insr !");
		MesTitres = (UBYTE **) realloc(MesTitres, (2) * sizeof(UBYTE *));
		MesTitres[1] = NULL;
		//cdin=FALSE;
	} else if (res == 1) 
	{
		MesTitres = (UBYTE **) realloc(MesTitres, sizeof(UBYTE *));
		MesTitres[0] = (UBYTE *) malloc(50);
		strcpy(MesTitres[0],"Pas de piste audio sur le CD !");
		MesTitres = (UBYTE **) realloc(MesTitres, (2) * sizeof(UBYTE *));
		MesTitres[1] = NULL;
		//cdin=FALSE;
	} else 
	{

    	strcpy( buf, IndexPath );
    	sprintf( cd, "ID%2.2d%6.6lx%6.6lx", t, a1 , a2 );
    	AddPart( buf, cd, sizeof(buf)-1 );


    	if ((f = Open(buf, MODE_OLDFILE)) == TRUE)
    	{
      	//ULONG i;

        	FGets(f, buf, sizeof(buf)-1);
        	//strcpy(Auteur, buf);
        	FGets(f, buf, sizeof(buf)-1);
        	//strcpy(Titre, buf);

        	for (i = 0 ; i < t ; i++)
        	{
            FGets(f, buf, sizeof(buf)-1);
            MesTitres = (UBYTE **) realloc(MesTitres, (i+1) * sizeof(UBYTE *));
				MesTitres[i] = (UBYTE *) malloc(strlen(buf)+1);
            strncpy(MesTitres[i], buf,strlen(buf)-1);
        	}

			MesTitres[i] = NULL;
			
        Close(f);


       // return TRUE;

    	}else
    	{
    		for(i=0;i<=nb_pistes;i++)
			{
				MesTitres = (UBYTE **) realloc(MesTitres, (i+1) * sizeof(UBYTE *));
				MesTitres[i] = (UBYTE *) malloc(strlen(MesPistes[i+1].Nom)+1);
				strcpy(MesTitres[i],MesPistes[i+1].Nom);
			};
			
			//MesTitres = (UBYTE **) realloc(MesTitres, (i+1) * sizeof(UBYTE *));
			MesTitres[i-1] = NULL;
			//MesTitres[i+1] = NULL;	
    	}
	
   }
/*
free_chooserlist (&chooser_list1);
make_chooserlist(&chooser_list1, MesTitres); 	
											
SetAttrs(gadgets[GID_CHOOSER1],
			CHOOSER_Labels, (ULONG)&chooser_list1,
			TAG_END);
											
RefreshGList(gadgets[GID_CHOOSER1],windows[WID_MAIN],NULL,GID_CHOOSER1);
*/
return FALSE;
}


BOOL testcd(void)
{

	//int i;
	int res=0;
	int OldTaille;

	BOOL cdin=TRUE;
	BOOL titreok;

	OldTaille = MesPistesInfo[0].taille;

	res = read_toc(1);

	printf("read_toc : %d\n", res);

	if (MesPistesInfo[0].taille != OldTaille)
	{
		titreok = GetIndex(nb_pistes, MesPistesInfo[3].deb-MesPistesInfo[0].deb,
			 MesPistesInfo[nb_pistes].deb + MesPistesInfo[nb_pistes].taille
			  - MesPistesInfo[0].deb);
	}
	return (cdin);
};

/*******************************************/
/*  InitialiseBibliothque                 */
/*  Ouvre une bibliothque                 */
/*******************************************/
static APTR InitLib(STRPTR libname, struct Library **libbase, ULONG version, int revision, BOOL required, BOOL close)
{
   struct Library *base;

   if(!libbase) return NULL;

   base = OpenLibrary(libname, version);

   if(base && revision)
      {
         if(base->lib_Version == version && base->lib_Revision < revision)
            {
               CloseLibrary(base);
               base = NULL;
            }
      }

   if(base && close)
      {
         CloseLibrary(base);
         base = NULL;
      }

   *libbase = base;

 //  if(!base && required) Abort(MSG_ErrorLib, libname, version, revision);
  	if(!base && required)
  	{
	 	puts("Failed to open "MUIMASTER_NAME".");
    	exit(1);
  	}

   return base;
}

struct ObjApp * CreateApp(void)
{
	struct ObjApp * Object;

	APTR	GROUP_ROOT_0, obj_aux0, obj_aux1, GR_grp_0;

	if (!(Object = AllocVec(sizeof(struct ObjApp), MEMF_PUBLIC|MEMF_CLEAR)))
		return(NULL);

	Object->STR_TX_label_0 = "00 00:00";

	Object->TX_label_0 = TextObject,
		MUIA_Background, MUII_TextBack,
		MUIA_Frame, MUIV_Frame_Text,
		MUIA_Text_Contents, Object->STR_TX_label_0,
		MUIA_Text_SetMin, TRUE,
	End;

	Object->SL_label_0 = SliderObject,
		MUIA_HelpNode, "SL_label_0",
		MUIA_Slider_Min, 0,
		MUIA_Slider_Max, 100,
		MUIA_Slider_Level, 0,
		MUIA_Slider_Quiet, TRUE,		
	End;

	obj_aux1 = Label2("Slider Title");

	obj_aux0 = GroupObject,
		MUIA_Group_Columns, 2,
		Child, obj_aux1,
		Child, Object->SL_label_0,
	End;

	Object->BT_label_5 = SimpleButton("|<");
	Object->BT_label_6 = SimpleButton("<<");
	Object->BT_label_7 = SimpleButton(">");
	Object->BT_label_8 = SimpleButton(">>");
	Object->BT_label_9 = SimpleButton(">|");

	GR_grp_0 = GroupObject,
		MUIA_HelpNode, "GR_grp_0",
		MUIA_Group_Horiz, TRUE,
		Child, Object->BT_label_5,
		Child, Object->BT_label_6,
		Child, Object->BT_label_7,
		Child, Object->BT_label_8,
		Child, Object->BT_label_9,
	End;

	GROUP_ROOT_0 = GroupObject,
		Child, Object->TX_label_0,
		Child, obj_aux0,
		Child, GR_grp_0,
	End;

	Object->WI_label_0 = WindowObject,
		MUIA_Window_Title, "window_title",
		MUIA_Window_ID, MAKE_ID('0', 'W', 'I', 'N'),
		MUIA_Window_AppWindow, TRUE,
		WindowContents, GROUP_ROOT_0,
	End;

	Object->App = ApplicationObject,
		MUIA_Application_Author, "NONE",
		MUIA_Application_Base, "NONE",
		MUIA_Application_Title, "NONE",
		MUIA_Application_Version, "$VER: NONE XX.XX (XX.XX.XX)",
		MUIA_Application_Copyright, "NOBODY",
		MUIA_Application_Description, "NONE",
		SubWindow, Object->WI_label_0,
	End;


	if (!Object->App)
	{
		FreeVec(Object);
		return(NULL);
	}

	DoMethod(Object->WI_label_0,
		MUIM_Window_SetCycleChain, Object->SL_label_0,
		Object->BT_label_5,
		Object->BT_label_6,
		Object->BT_label_7,
		Object->BT_label_8,
		Object->BT_label_9,
		0
		);

	DoMethod(Object->WI_label_0,MUIM_Notify,MUIA_Window_CloseRequest,TRUE, 
		Object->App,2,MUIM_Application_ReturnID,MUIV_Application_ReturnID_Quit);

	
	DoMethod(Object->BT_label_7, MUIM_Notify, MUIA_Pressed, FALSE,
                                        Object->BT_label_7,  2, MUIM_CallHook, &hook_PlayCD);
	
	DoMethod(Object->BT_label_9, MUIM_Notify, MUIA_Pressed, FALSE,
                                        Object->BT_label_9,  2, MUIM_CallHook, &hook_NextTrack);

	DoMethod(Object->BT_label_5, MUIM_Notify, MUIA_Pressed, FALSE,
                                        Object->BT_label_5,  2, MUIM_CallHook, &hook_PrevTrack);


	set(Object->WI_label_0,
		MUIA_Window_Open, TRUE
		);

	return(Object);
}

void DisposeApp(struct ObjApp * Object)
{
/*
	if(data->player_inputhandler_added)
	{
		DoMethod(Object->App, MUIM_Application_RemInputHandler, &data->player_ihnode);
	}
*/
	MUI_DisposeObject(Object->App);
	FreeVec(Object);
}

/*
	data->cachecleanup_ihnode.ihn_Object = obj; 
	data->cachecleanup_ihnode.ihn_Flags = MUIIHNF_TIMER; 
	data->cachecleanup_ihnode.ihn_Millis = 60 * 1000; 
	data->cachecleanup_ihnode.ihn_Method = MM_Application_CleanupCache; 
toutes les minutes, on vrifie si c'est intressant de nettoyer le cache 
et 	DoMethod(obj, MUIM_Application_AddInputHandler, &data->cachecleanup_ihnode);     pour l'ajout effectif donc 
et DoMethod(obj, MUIM_Application_RemInputHandler, &data->cachecleanup_ihnode);      pour le virer  la fin
*/

int main(void)
{
  ULONG	signals;
  BOOL	running = TRUE;
  struct ObjApp *app;
  BOOL testinit = FALSE;
  BOOL cd_in = FALSE;
 
  ULONG fast_re;
  ULONG fast_fo;

  static int curr_min;
  static int curr_sec;

  char mytext[30];

  MUIMasterBase=InitLib(MUIMASTER_NAME, (APTR)&MUIMasterBase, MUIMASTER_VMIN, 0, TRUE, FALSE);  
  IntuitionBase=InitLib("intuition.library",(APTR)&IntuitionBase, 44, 0, TRUE, FALSE);

  app = CreateApp();
  if (!app) 
  {
    puts("Failed to create Application.");
    exit(1);
  }  

  scsi.unit = 3;
  strcpy(scsi.device, "ide.device");
  
  testinit = init (scsi.device,scsi.unit);

  if(testinit) printf("device init ok");
  else exit(1);

  inquiry (TRUE);

  cd_in=testcd();

  read_subchannel (TRUE, 64, 1, 0);

  while (running)
  {
    switch (DoMethod(app->App,MUIM_Application_Input,&signals))
    {
      case MUIV_Application_ReturnID_Quit:
			running = FALSE;
		break;
    }
    if (running && signals) Wait(signals);
	 
 		read_subchannel (TRUE, 64, 1, 0);

		GetAttr( MUIA_Pressed, app->BT_label_6, &fast_re);
		GetAttr( MUIA_Pressed, app->BT_label_8, &fast_fo);					
			

		if(fast_re==1) play_from(abs_pos - 300, MesPistesInfo[nb_pistes].fin-abs_pos+300);
		if(fast_fo==1) play_from(abs_pos + 525, MesPistesInfo[nb_pistes].fin-abs_pos-525);

		printf("fast forward detected : %ld\n", fast_re);

		curr_min = (current_pos) / 75 / 60;
		curr_sec = (current_pos / 75) % 60;

		if(current_track == 170) current_track = 0;

		sprintf(mytext, "%2.2d %2.2d:%2.2d",	current_track, curr_min, curr_sec);
				
		printf("%s\n", mytext);

		set(app->TX_label_0, MUIA_Text_Contents, mytext);

		set(app->SL_label_0,	MUIA_Slider_Level, 100*current_pos / MesPistesInfo[current_track].taille);		
		 
  }

  deinitscsi();

  DisposeApp(app);

  if(MUIMasterBase) CloseLibrary(MUIMasterBase);
  if(IntuitionBase) CloseLibrary(IntuitionBase); 

  exit(0);
}