#ifndef MAKE_ID
#define MAKE_ID(a,b,c,d) ((ULONG) (a)<<24 | (ULONG) (b)<<16 | (ULONG) (c)<<8 | (ULONG) (d))
#endif

#ifdef _DCC
#define __inline
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
// #include <libraries/dos.h>
#include <clib/dos_protos.h>
#include <clib/icon_protos.h>

#include <workbench/startup.h>



#include "interface.h"


struct T_MesPistes MesPistes[256];
UBYTE **MesTitres; 

UWORD topborder;

int mapiste = 1;
int first_track;
int last_track;
int nb_pistes =0;
int current_track;
int current_pos;
int abs_pos;
int toclen;

ULONG MonVolume;

struct PistesInfo MesPistesInfo[256];


struct IntuitionBase	*IntuitionBase	= NULL;
struct Library			*MUIMasterBase	= NULL;
struct Library  		*UtilityBase = NULL;
struct Library 		*IconBase = NULL;

struct WBStartup *wbs = NULL;


static Object *app = NULL;
static Object *window = NULL;

struct ObjApp *myapp=NULL;

struct Scsi {
        int unit;
        char device[60];
} scsi;

extern BOOL init(char *device, int number);
extern void inquiry (BOOL parsedoutput);
extern void deinitscsi(void);
extern void play_audio (int starttrack, int endtrack);
extern void play_audio_scsi12 (long starttrack, long endtrack);
extern int  read_toc (int toclong);
extern void motor (int motorstatus);
extern void read_subchannel (BOOLEAN parsed, UBYTE subchannel, UBYTE subchannelformat, UBYTE track);
extern void play_from(int pos_deb, int pos_fin);
extern void pause_resume(int resume);
extern void stop_playing(void);
extern void set_volume (int vol0, int vol1, int vol2, int vol3);

STRPTR IndexPath = "CD_Titles:";
static UBYTE cd[20];

struct MUI_CustomClass *cl_playero;

#define PLAYERBASE			 (TAG_USER + 0x61843728)

#define MUIA_Player_Executable  (PLAYERBASE + 1)

#define MUIM_Player_PlayAudio   (PLAYERBASE + 20)
#define MUIM_Player_NextTrack   (PLAYERBASE + 21)
#define MUIM_Player_PrevTrack   (PLAYERBASE + 22)
#define MUIM_Player_Slider		  (PLAYERBASE + 23)
#define MUIM_Player_Stop		  (PLAYERBASE + 24)
#define MUIM_Player_Eject		  (PLAYERBASE + 25)
#define MUIM_Player_Volume		  (PLAYERBASE + 26)

#define MUIM_Player_Freeze_Slider_Pos (PLAYERBASE + 30)

#define MUIM_Player_Refresh   	(PLAYERBASE + 33)
#define MUIM_Player_FastButtons  (PLAYERBASE + 34)



/*
#define MUIA_Debug_LogMode     (PLAYERBASE + 2)
#define MUIA_Debug_LogFile	   (DEBUGBASE + 3)

#define MUIA_Debug_DumpMode    (DEBUGBASE + 4)
#define MUIA_Debug_DumpFile    (DEBUGBASE + 5)

#define MUIA_Debug_CurrentHit  (DEBUGBASE + 6)


#define MUIV_Debug_Manual      (DEBUGBASE + 10)
#define MUIV_Debug_Auto        (DEBUGBASE + 11)


#define MUIM_Debug_ShowHit	       (DEBUGBASE + 20)
#define MUIM_Debug_PerformAction   (DEBUGBASE + 21)
#define MUIM_Debug_Analyze		   (DEBUGBASE + 22)
*/

struct PlayerData
{
	char m_executable[128];
	int  m_current_hit;
	int  player_pause_mode;
	int  refresh_slider_pos;
	int  eject_state;


	Object *App;
	Object *WI_label_0;
	Object *TX_label_0;
	Object *SL_label_0;
	Object *SL_label_1;
	Object *BT_label_5;
	Object *BT_label_6;
	Object *BT_label_7;
	Object *BT_label_8;
	Object *BT_label_9;
	Object *BT_label_10;
	Object *STR_TX_label_0;


	ULONG player_fastbt_timer_count;
	ULONG player_fastbt_timer_wait;

	ULONG player_fastbt_inputhandler_added;
	struct MUI_InputHandlerNode player_fastbt_ihnode;

	/* time refresh
	 */
	ULONG player_refresh_timer_count;
	ULONG player_refresh_timer_wait;

	ULONG player_refresh_inputhandler_added;
	struct MUI_InputHandlerNode player_refresh_ihnode;
};


static ULONG Player_TimeUpdate(struct PlayerData *data)
{
static	char mytext[30];
	
   static int curr_min;
   static int curr_sec;

	
	if(--data->player_refresh_timer_count == 0)
	{
		data->player_refresh_timer_count = data->player_refresh_timer_wait;

		/*
		 * TODO: Make this one asynchronous? Probably good idea...
		 */
				 
 		read_subchannel (TRUE, 64, 1, 0);

		curr_min = (current_pos) / 75 / 60;
		curr_sec = (current_pos / 75) % 60;

		if(current_track == 170) current_track = 0;

		sprintf(mytext, "%2.2d %2.2d:%2.2d",	current_track, curr_min, curr_sec);
				
		printf("%s\n", mytext);

		set(data->TX_label_0, MUIA_Text_Contents, mytext);


		if(data->refresh_slider_pos == 1)
		{
			set(data->SL_label_0, MUIA_Slider_Level, 100*current_pos / MesPistesInfo[current_track].taille);	
		}
		

	}

	return (0);
}


BOOL
GetIndex( int t, ULONG a1, ULONG a2 )
{
    UBYTE buf[256];
    BPTR f;
	 UBYTE Auteur[50];
	 UBYTE Titre[50];
	 int res=0;
	 int i;
    /* Read an index file from the disk */
											
	if (res == 2) 
	{
		MesTitres = (UBYTE **) realloc(MesTitres, sizeof(UBYTE *));
		MesTitres[0] = (UBYTE *) malloc(50);
		strcpy(MesTitres[0],"Pas de CD insr !");
		MesTitres = (UBYTE **) realloc(MesTitres, (2) * sizeof(UBYTE *));
		MesTitres[1] = NULL;

	} else if (res == 1) 
	{
		MesTitres = (UBYTE **) realloc(MesTitres, sizeof(UBYTE *));
		MesTitres[0] = (UBYTE *) malloc(50);
		strcpy(MesTitres[0],"Pas de piste audio sur le CD !");
		MesTitres = (UBYTE **) realloc(MesTitres, (2) * sizeof(UBYTE *));
		MesTitres[1] = NULL;

	} else 
	{

    	strcpy( buf, IndexPath );
    	sprintf( cd, "ID%2.2d%6.6lx%6.6lx", t, a1 , a2 );
    	AddPart( buf, cd, sizeof(buf)-1 );


    	if ((f = Open(buf, MODE_OLDFILE)) == TRUE)
    	{

        	FGets(f, buf, sizeof(buf)-1);
        	FGets(f, buf, sizeof(buf)-1);

        	for (i = 0 ; i < t ; i++)
        	{
            FGets(f, buf, sizeof(buf)-1);
            MesTitres = (UBYTE **) realloc(MesTitres, (i+1) * sizeof(UBYTE *));
				MesTitres[i] = (UBYTE *) malloc(strlen(buf)+1);
            strncpy(MesTitres[i], buf,strlen(buf)-1);
        	}

			MesTitres[i] = NULL;
			
        Close(f);

    	}else
    	{
    		for(i=0;i<=nb_pistes;i++)
			{
				MesTitres = (UBYTE **) realloc(MesTitres, (i+1) * sizeof(UBYTE *));
				MesTitres[i] = (UBYTE *) malloc(strlen(MesPistes[i+1].Nom)+1);
				strcpy(MesTitres[i],MesPistes[i+1].Nom);
			};
			

			MesTitres[i-1] = NULL;
    	}
	
   }

return FALSE;
}


BOOL testcd(void)
{

	//int i;
	int res=0;
	int OldTaille;

	BOOL cdin=TRUE;
	BOOL titreok;

	OldTaille = MesPistesInfo[0].taille;

	res = read_toc(1);

	printf("read_toc : %d\n", res);

	if (MesPistesInfo[0].taille != OldTaille)
	{
		titreok = GetIndex(nb_pistes, MesPistesInfo[3].deb-MesPistesInfo[0].deb,
			 MesPistesInfo[nb_pistes].deb + MesPistesInfo[nb_pistes].taille
			  - MesPistesInfo[0].deb);
	}
	return (cdin);
};


static ULONG Player_Eject(struct PlayerData *data)
{

	if (data->eject_state == 0) data->eject_state = 1;
	else	data->eject_state = 0;

	motor(data->eject_state | 2);

	return TRUE;
}


static ULONG Player_Slider_Pos(struct PlayerData *data)
{
	ULONG new_pos;

	read_subchannel (TRUE, 64, 1, 0);

	GetAttr(MUIA_Slider_Level, data->SL_label_0, (ULONG *)&new_pos);

	new_pos = 150 + (new_pos * MesPistesInfo[current_track].taille / 100);

	printf("new : %ld new_pos : %ld, new_size : %ld , total : %ld , fin : %ld\n",new_pos, 
					MesPistesInfo[current_track].deb+new_pos, MesPistesInfo[0].taille-MesPistesInfo[current_track].fin-new_pos, MesPistesInfo[0].taille, MesPistesInfo[nb_pistes].fin);

	// play_from(MesPistesInfo[current_track].deb+new_pos, MesPistesInfo[0].taille-MesPistesInfo[current_track].fin-new_pos);
	play_from(MesPistesInfo[current_track].deb+new_pos, MesPistesInfo[nb_pistes].fin);


	data->refresh_slider_pos = 1;

	if(data->player_pause_mode == 0)
	{
		set(data->BT_label_7, MUIA_Text_Contents, "II");
   	data->player_pause_mode = 1;
	}

	return TRUE;
}


static ULONG Player_fastbt(struct PlayerData *data)
{
	static int fast_re=0;
	static int fast_fo=0;

	
	if(--data->player_fastbt_timer_count == 0)
	{
		data->player_fastbt_timer_count = data->player_fastbt_timer_wait;

		/*
		 * TODO: Make this one asynchronous? Probably good idea...
		 */
				 
 		read_subchannel (TRUE, 64, 1, 0);

		GetAttr( MUIA_Pressed, data->BT_label_6, (ULONG *) &fast_re);
		GetAttr( MUIA_Pressed, data->BT_label_8, (ULONG *) &fast_fo);					
			

		if(fast_re==1) 
		{
			if(abs_pos-300 < MesPistesInfo[0].deb||abs_pos-300 <0)
			{	
				printf("here %i %i !\n", MesPistesInfo[0].deb, abs_pos);
				play_from(MesPistesInfo[0].deb+150, MesPistesInfo[nb_pistes].fin);
			}else
		   {
				printf("ok !\n");
				play_from(abs_pos - 300, MesPistesInfo[nb_pistes].fin);
			}
		}
		if(fast_fo==1) 
		{
			if(abs_pos+525 < MesPistesInfo[nb_pistes].fin)	play_from(abs_pos + 525, MesPistesInfo[nb_pistes].fin);
		}

		if(data->player_pause_mode == 0 && (fast_re || fast_fo))
		{
			set(data->BT_label_7, MUIA_Text_Contents, "II");
   		data->player_pause_mode = 1;
		}

	}

	return (0);
}



// Partie cration/gestion interface

static ULONG Player_NextTrack(struct PlayerData *data)
{		

		  mapiste = mapiste + 1;

  		  if(mapiste > nb_pistes) mapiste = nb_pistes;

		  printf("piste : %d, last track : %d\n", mapiste, last_track);

		  play_audio_scsi12(MesPistesInfo[mapiste].deb, MesPistesInfo[nb_pistes].fin-MesPistesInfo[mapiste].deb);

        return TRUE;
}

static ULONG Player_PrevTrack(struct PlayerData *data)
{          
		  
		  mapiste = mapiste - 1;
			
		  if(mapiste ==0) mapiste = 1;

		  printf("piste : %d, last track : %d\n", mapiste, last_track);

		  play_audio_scsi12(MesPistesInfo[mapiste].deb, MesPistesInfo[nb_pistes].fin-MesPistesInfo[mapiste].deb);


        return TRUE;
}

static ULONG Player_StopPlaying(struct PlayerData *data)
{          

		  printf("Stop Playing\n");


		  stop_playing();

		  set(data->BT_label_7, MUIA_Text_Contents, ">");
	  
		  data->player_pause_mode = -1;

        return TRUE;
}


static ULONG Player_Volume(struct PlayerData *data)
{
	ULONG new_pos;

	GetAttr(MUIA_Slider_Level, data->SL_label_1, (ULONG *)&new_pos);

	new_pos = (new_pos * 255 / 100);

	printf("sound level :%ld \n", new_pos);

	set_volume(new_pos, new_pos, 0, 0);

}

static ULONG Player_PlayAudio(struct PlayerData *data)
{
	// printf("Let's play !!!\n");
	//	  printf("piste : %d, last track : %d\n", mapiste, last_track);

	
	if(data->player_pause_mode == -1)
	{
		play_audio_scsi12(MesPistesInfo[mapiste].deb, MesPistesInfo[0].taille);
		set(data->BT_label_7, MUIA_Text_Contents, "II");
	  	data->player_pause_mode = 1;
	}else if(data->player_pause_mode == 0)
	{	  
	  set(data->BT_label_7, MUIA_Text_Contents, "II");
	  data->player_pause_mode = 1;
	  pause_resume(1);
	}else
	{	  
	  set(data->BT_label_7, MUIA_Text_Contents, ">");
	  data->player_pause_mode = 0;
	  pause_resume(0);
	}

        return (ULONG)TRUE;
}



static ULONG PlayerNew(struct IClass *cl, Object *obj, struct opSet *msg)
{

	Object	*GROUP_ROOT_0, *obj_aux0, *obj_aux1, *GR_grp_0;

	Object *App;
	Object *WI_label_0;
	Object *TX_label_0;
	Object *SL_label_0;
	Object *SL_label_1;
	Object *BT_label_5;
	Object *BT_label_6;
	Object *BT_label_7;
	Object *BT_label_8;
	Object *BT_label_9;
	Object *BT_label_10;
	Object *BT_label_11;

	APTR *myImage;
	Object *myButton;

	Object *STR_TX_label_0;

	// myImage = ImageObject, MUIA_Image_Spec, "5:Skins/BackTrack.iff", End;

	obj = (Object *)DoSuperNew(cl, obj, 
		Child, TX_label_0 = TextObject,
			MUIA_Background, MUII_TextBack,
			MUIA_Frame, MUIV_Frame_Text,
			MUIA_Text_Contents, "00 00:00",
			MUIA_Text_SetMin, TRUE,
		End,
		Child, GroupObject,
			MUIA_Group_Columns, 2,
			Child, Label2("Volume                                          "),
			Child, SL_label_1 = SliderObject,
				MUIA_HelpNode, "SL_label_1",
				MUIA_Slider_Min, 0,
				MUIA_Slider_Max, 100,
				MUIA_Slider_Level, 75,
				MUIA_Slider_Quiet, FALSE,		
			End,
		End,
		Child, GroupObject,
			MUIA_Group_Columns, 2,
			Child, Label2("Slider Title"),
			Child, SL_label_0 = SliderObject,
				MUIA_HelpNode, "SL_label_0",
				MUIA_Slider_Min, 0,
				MUIA_Slider_Max, 100,
				MUIA_Slider_Level, 0,
				MUIA_Slider_Quiet, TRUE,		
			End,
		End,
			Child, GroupObject,
			MUIA_HelpNode, "GR_grp_0",
			MUIA_Group_Horiz, TRUE,
			Child, BT_label_11 = SimpleButton("E\033I[5:PROGDIR:Skins/BackTrack.iff]"),
			Child, BT_label_10 = SimpleButton("[]\033I[5:PROGDIR:Skins/BackTrack.iff]"),
			Child, BT_label_5 = SimpleButton("|<"),
			Child, BT_label_6 = SimpleButton("<<"),
			Child, BT_label_7 = SimpleButton(">"),
			Child, BT_label_8 = SimpleButton(">>"),
			Child, BT_label_9 = SimpleButton(">|"),
			Child, myImage = ImageObject, 		
					 MUIA_FixWidth, 20,
					 MUIA_FixHeight, 20,
					 MUIA_Image_FreeVert, TRUE,
					 MUIA_Image_FreeHoriz, TRUE,
					 MUIA_Image_Spec, "5:PROGDIR:Skins/BackTrack.iff",
					 MUIA_CycleChain, 1, 
					 MUIA_InputMode, MUIV_InputMode_Toggle,
					 MUIA_Background, MUII_ButtonBack,
					 MUIA_ShowSelState,TRUE, 
			End, 
		End,
		TAG_MORE, (struct opSet *) msg->ops_AttrList);

	if (obj)
	{
		struct PlayerData *data = (struct PlayerData *)INST_DATA(cl, obj);
		struct TagItem *tags,*tag;

		/* parse initial taglist */
		data->eject_state = 1;
		data->refresh_slider_pos = 1;
		data->player_pause_mode = -1;
		data->TX_label_0 = TX_label_0;
		data->SL_label_0 = SL_label_0;
		data->SL_label_1 = SL_label_1;
		data->BT_label_6 = BT_label_6;
		data->BT_label_7 = BT_label_7;
		data->BT_label_8 = BT_label_8;
		data->BT_label_10= BT_label_10;

		/* notifications */

		//DoMethod(myImage, MUIM_Notify, MUIA_Pressed, TRUE, obj, 3, MUIM_Set, MUIA_Image_Spec, "5:DH8:SCSI_Player_mos_method/Skins/Any");

		DoMethod(BT_label_7, MUIM_Notify, MUIA_Pressed, FALSE, obj, 1, MUIM_Player_PlayAudio);
		DoMethod(BT_label_9, MUIM_Notify, MUIA_Pressed, FALSE, obj, 1, MUIM_Player_NextTrack);
		DoMethod(BT_label_5, MUIM_Notify, MUIA_Pressed, FALSE, obj, 1, MUIM_Player_PrevTrack);
		DoMethod(BT_label_10, MUIM_Notify, MUIA_Pressed, FALSE, obj, 1, MUIM_Player_Stop);
		DoMethod(BT_label_11, MUIM_Notify, MUIA_Pressed, FALSE, obj, 1, MUIM_Player_Eject);

		// DoMethod(data->SL_label_0, MUIM_Notify, MUIA_Slider_Level, MUIV_EveryTime, obj, 1, MUIM_Player_Slider);
		DoMethod(data->SL_label_0, MUIM_Notify, MUIA_Pressed, TRUE, obj, 1, MUIM_Player_Freeze_Slider_Pos );
		DoMethod(data->SL_label_0, MUIM_Notify, MUIA_Pressed, FALSE, obj, 1, MUIM_Player_Slider);

		DoMethod(data->SL_label_1, MUIM_Notify, MUIA_Slider_Level, MUIV_EveryTime, obj, 1, MUIM_Player_Volume);

	}

	return (ULONG)obj;
}


static ULONG PlayerDispose(struct IClass *cl, Object *obj, struct opSet *msg)
{
	struct PlayerData *data;

	data = (struct PlayerData *)INST_DATA(cl, obj);

    return (DoSuperMethodA(cl, obj, msg));
}

static ULONG PlayerSetup(struct IClass *cl, Object *obj, APTR msg)
{
	struct PlayerData *data;

	data = (struct PlayerData *)INST_DATA(cl, obj);

    if(!DoSuperMethodA(cl, obj, msg))
    	return 0;

	data->player_refresh_timer_count = 1;
	data->player_refresh_timer_wait = 1;

	data->player_refresh_ihnode.ihn_Object = obj;
	data->player_refresh_ihnode.ihn_Flags = MUIIHNF_TIMER;
	data->player_refresh_ihnode.ihn_Millis = 1;
	data->player_refresh_ihnode.ihn_Method = MUIM_Player_Refresh ;
	DoMethod(_app(obj), MUIM_Application_AddInputHandler, &data->player_refresh_ihnode);
	data->player_refresh_inputhandler_added = TRUE;


	data->player_fastbt_timer_count = 1;
	data->player_fastbt_timer_wait = 1;

	data->player_fastbt_ihnode.ihn_Object = obj;
	data->player_fastbt_ihnode.ihn_Flags = MUIIHNF_TIMER;
	data->player_fastbt_ihnode.ihn_Millis = 1;
	data->player_fastbt_ihnode.ihn_Method = MUIM_Player_FastButtons;
	DoMethod(_app(obj), MUIM_Application_AddInputHandler, &data->player_fastbt_ihnode);
	data->player_fastbt_inputhandler_added = TRUE;


    return TRUE;
}

static ULONG PlayerCleanup(struct IClass *cl, Object *obj, APTR msg)
{
	struct PlayerData *data;

	data = (struct PlayerData *)INST_DATA(cl, obj);

	if(data->player_refresh_inputhandler_added)
	{
		DoMethod(_app(obj), MUIM_Application_RemInputHandler, &data->player_refresh_ihnode);
	}

	if(data->player_fastbt_inputhandler_added)
	{
		DoMethod(_app(obj), MUIM_Application_RemInputHandler, &data->player_fastbt_ihnode);
	}


    return DoSuperMethodA(cl, obj, msg);
}

static ULONG PlayerSet(struct IClass *cl, Object *obj, struct opSet *msg)
{
	struct PlayerData *data;
	struct TagItem *tags, *tag;

	data = (struct PlayerData *)INST_DATA(cl, obj);

/*
	for (tags=((struct opSet *)msg)->ops_AttrList;tag=NextTagItem(&tags);)
	{
		switch (tag->ti_Tag)
		{

			case MUIM_Player_Refresh:
			{
				if(data->bgrandom_inputhandler_added)
				{
					DoMethod(obj, MUIM_Application_RemInputHandler, &data->bgrandom_ihnode);
					data->bgrandom_inputhandler_added = FALSE;
				}

				if(tag->ti_Data)
				{
					data->bgrandom_timer_wait = data->bgrandom_timer_count = (ULONG)tag->ti_Data;

					data->bgrandom_ihnode.ihn_Object = obj;
					data->bgrandom_ihnode.ihn_Flags = MUIIHNF_TIMER;
					data->bgrandom_ihnode.ihn_Millis = 10;
					data->bgrandom_ihnode.ihn_Method = MUIM_Player_Refresh ;

					DoMethod(obj, MUIM_Application_AddInputHandler, &data->bgrandom_ihnode);

					data->bgrandom_inputhandler_added = TRUE;

				}
			}
*/
/*

			case MUIA_Debug_LogMode:
				data->m_ramdebug_mode = tag->ti_Data;
				SetAttrs(data->m_cy_ramdebug_mode, MUIA_Cycle_Active, data->m_ramdebug_mode, TAG_END);
				break;

			case MUIA_Debug_DumpMode:
				data->m_ramdebug_mode = tag->ti_Data;
				SetAttrs(data->m_cy_dump_mode, MUIA_Cycle_Active, data->m_dump_mode, TAG_END);
				break;

			case MUIA_Debug_Executable:
				if(tag->ti_Data)
				{
					strcpy(data->m_executable, (char *) tag->ti_Data);
					SetAttrs(data->m_st_executable, MUIA_Text_Contents, data->m_executable, TAG_END);
				}
				break;

			case MUIA_Debug_LogFile:
				if(tag->ti_Data)
				{
					strcpy(data->m_ramdebugfile, (char *) tag->ti_Data);
					SetAttrs(data->m_st_ramdebug_file, MUIA_Text_Contents, data->m_ramdebugfile, TAG_END);
				}
				break;

			case MUIA_Debug_DumpFile:
				if(tag->ti_Data)
				{
					strcpy(data->m_dumpfile, (char *) tag->ti_Data);
					SetAttrs(data->m_st_dump_file, MUIA_Text_Contents, data->m_dumpfile, TAG_END);
				}
				break;

			case MUIA_Debug_CurrentHit:
				data->m_current_hit = tag->ti_Data;
				SetAttrs(data->m_sl_current_hit, MUIA_Slider_Level, data->m_current_hit, TAG_END);
				break;

*/
//		}
//	}


	return (DoSuperMethodA(cl, obj, msg));
}

DISPATCHERPROTO(PlayerDispatcher)
{
	//struct IClass *cl = (struct IClass * ) REG_A0;
	//Object *obj = (Object *) REG_A2;
	//struct Msg *msg  = (struct Msg *) REG_A1;

	struct PlayerData *data = (struct PlayerData *)INST_DATA(cl, obj);

	switch(msg->MethodID)
	{
		case OM_NEW :						return PlayerNew(cl, obj, (struct opSet *) msg);
		case OM_DISPOSE :					return PlayerDispose(cl, obj, (struct opSet *)msg);
		case OM_SET:						return PlayerSet(cl, obj, (struct opSet *)msg);

      case MUIM_Setup:				return PlayerSetup(cl, obj, (APTR) msg);
      case MUIM_Cleanup:				  return PlayerCleanup(cl, obj, (APTR) msg);

		case MUIM_Player_PlayAudio :	return Player_PlayAudio(data);
		case MUIM_Player_NextTrack :	return Player_NextTrack(data);
		case MUIM_Player_PrevTrack :	return Player_PrevTrack(data);
		case MUIM_Player_Stop :			return Player_StopPlaying(data);
		case MUIM_Player_Eject :			return Player_Eject(data);
		case MUIM_Player_Volume :			return Player_Volume(data);

		case MUIM_Player_Freeze_Slider_Pos : 
		{	
			data->refresh_slider_pos = 0;
		}
		break;

		case MUIM_Player_Slider		:	return Player_Slider_Pos(data);

		case MUIM_Player_Refresh 	:  return Player_TimeUpdate(data);
		case MUIM_Player_FastButtons 	:  return Player_fastbt(data);


	}
		return DoSuperMethodA(cl, obj, msg);
}

Object * OpenMainWindow(void)
{
	Object *obj_player;

	window = WindowObject,
		MUIA_Window_Title, "window_title",
		MUIA_Window_ID, MAKE_ID('0', 'W', 'I', 'N'),
		MUIA_Window_AppWindow, TRUE,
		WindowContents,  obj_player = (Object *) NewObject(cl_playero->mcc_Class, NULL, TAG_DONE),										
	End;

	app = (Object *)ApplicationObject,
		MUIA_Application_Author, "NONE",
		MUIA_Application_Base, "NONE",
		MUIA_Application_Title, "NONE",
		MUIA_Application_Version, "$VER: NONE XX.XX (XX.XX.XX)",
		MUIA_Application_Copyright, "NOBODY",
		MUIA_Application_Description, "NONE",
		SubWindow, window,
	End;


	if (app)
	{
	
		DoMethod(window,
			MUIM_Notify, MUIA_Window_CloseRequest, TRUE,
			app, 2,
			MUIM_Application_ReturnID, MUIV_Application_ReturnID_Quit);

		SetAttrs(window, MUIA_Window_Open, TRUE, TAG_END);
	}

	return app;
}





int Initialize(void)
{
	int res = 1;

	IntuitionBase = (struct IntuitionBase *)OpenLibrary("intuition.library", 39L);
	MUIMasterBase = OpenLibrary(MUIMASTER_NAME, MUIMASTER_VMIN);
	UtilityBase = OpenLibrary("utility.library", 39);

	if (IntuitionBase == NULL)
	{
		printf("Can't open 'intuition.library' V39\n");
		res = 0;
	}
	if (MUIMasterBase == NULL)
	{
		printf("Can't open '%s' V%d\n", MUIMASTER_NAME, MUIMASTER_VMIN);
		res = 0;
	}
	if (UtilityBase == NULL)
	{
		printf("Can't open 'utility.library' V39\n");
		res = 0;
	}

	cl_playero = MUI_CreateCustomClass(NULL, MUIC_Group, NULL, sizeof(struct PlayerData), ENTRY(PlayerDispatcher));
	if (cl_playero == NULL)
	{
		printf("Can't create debug internal class\n");
		res = 0;
	}

	return res;
}

void DeInitialize(void)
{
	MUI_DeleteCustomClass(cl_playero);
	CloseLibrary(UtilityBase);
	CloseLibrary(MUIMasterBase);
	CloseLibrary((struct Library *)IntuitionBase);
}


int main(int argc, char *argv[])
{
	int res = 0;
  BOOL testinit = FALSE;
  BOOL cd_in = FALSE;
 

	if ( (IconBase = OpenLibrary("icon.library", 0L) ) ) 
	{
    CONST_STRPTR *ToolType_String;
    UBYTE **ToolTypeArray;

    ToolType_String = (CONST_STRPTR *)argv;

    ToolTypeArray = ArgArrayInit(argc, ToolType_String);

    	if (ToolTypeArray) 
		{
        STRPTR temp;
        // Our defalt value for Autosync is 5, it gives a good result
        //autosync = ArgInt( ToolTypeArray, "AUTOSYNC", 5);

        // AHI_AudioID = ArgInt( ToolTypeArray, "AUDIOID", 0L);

		  scsi.unit = ArgInt( ToolTypeArray, "UNIT", 3);

		  printf("unit : %d\n", scsi.unit);

		  temp = ArgString (ToolTypeArray, "DEVICE", "ide.device");

		  strcpy(scsi.device, temp);

		  printf("device : %s Unit : %d\n", scsi.device, scsi.unit);


        // temp = ArgString (ToolTypeArray, "CGX_MODE", "AUTO");
        
		  //if ( MatchToolValue(temp, "AUTO") )     cgx_mode=0;
        //if ( MatchToolValue(temp, "OVERLAY") )  cgx_mode=1;
        //if ( MatchToolValue(temp, "VMEM") )     cgx_mode=2;
        //if ( MatchToolValue(temp, "WPA") )      cgx_mode=3;

        //dvd_device = ArgString (ToolTypeArray, "DVD_DEVICE", DEFAULT_CDROM_DEVICE);
        //dvd_title = ArgInt (ToolTypeArray, "DVD_TITLE", 0);

        //cdrom_device = ArgString (ToolTypeArray, "VCD_DEVICE", DEFAULT_DVD_DEVICE );
        //vcd_track = ArgInt (ToolTypeArray, "VCD_TRACK", 0);

        // cgx_border      =  ( FindToolType( ToolTypeArray, "IWANTMYBORDER") ) ? TRUE : FALSE;
        // cgx_buffering   =  ( FindToolType( ToolTypeArray, "NOMULTIBUFFERING") ) ? FALSE : TRUE;
        // frame_dropping  =  ( FindToolType( ToolTypeArray, "FRAMEDROP") ) ? 1 : 0;

        //if (dvd_title || vcd_track) argc=1;

        ArgArrayDone();
    	}
    	CloseLibrary(IconBase);
	}



		testinit = init (scsi.device,scsi.unit);

		if(testinit) printf("device init ok");
	   else {deinitscsi();exit(1);}

		inquiry (TRUE);

		cd_in=testcd();

 	   read_subchannel (TRUE, 64, 1, 0);



	if (Initialize())
	{
		app = OpenMainWindow();
		if (app)
		{
			ULONG sigs = 0;

			while (DoMethod(app,MUIM_Application_NewInput,&sigs) != ((unsigned int) MUIV_Application_ReturnID_Quit))
			{
				if (sigs)
				{
					sigs = Wait(sigs | SIGBREAKF_CTRL_C);
					if (sigs & SIGBREAKF_CTRL_C) break;
				}
			}

		   deinitscsi();

			
			SetAttrs(window, MUIA_Window_Open, FALSE, TAG_END);
			MUI_DisposeObject(app);
		}
		else
		{
			res = 2;
		}
	}
	else
	{
		res = 1;
	}

	DeInitialize();

	return res;
}
